import type { Plugin } from '..';
export type ESModuleOptions = {
    /**
     * ESM npm-package names
     */
    include: string[];
    /**
     * Options of esbuild.build()
     */
    buildOptions?: import('esbuild').BuildOptions;
    /**
     * @default ".esmodule"
     */
    cacheDir?: string;
};
/**
 * Support use ESM npm-package in Electron-Main.
 * e.g. `execa`, `node-fetch`, `got`, etc.
 */
export declare function esmodule(options: ESModuleOptions): Plugin;
